#include <bits/stdc++.h>
using namespace std;

#define st first
#define nd second
#define pb push_back
using ll = long long;
using db = double;
using ldb = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;

const int N = 2e4 + 7;
const ll INF = 1e18;
vector<pil> g[N];
ll dist[N];
bool vis[N];

int main() {
    int n, m;
    scanf("%d%d", &n, &m);
    for (int i = 0; i < n; ++i) {
        ll c;
        scanf("%lld", &c);
        g[0].pb({i + 1, c});
        g[i + 1].pb({n + 1, c});
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        ll c;
        scanf("%d%d%lld", &u, &v, &c);
        ++u; ++v;
        g[u].push_back({v, c});
        g[v].push_back({u, c});
    }

    priority_queue<pli> q;
    for (int i = 0; i <= n + 1; ++i)
        dist[i] = INF;
    dist[0] = 0;
    q.push({0, 0});

    while (!q.empty()) {
        auto [dd, v] = q.top();
        q.pop();

        if (vis[v])
            continue;
        vis[v] = true;

        int d = dist[v];
        for (auto [s, c] : g[v])
            if (d + c < dist[s]) {
                dist[s] = d + c;
                q.push({-dist[s], s});
            }
    }

    printf("%lld\n", dist[n + 1]);

    return 0;
}
